Bug 17233 - Add 008 value builder plugin for MARC21 classifications
Summary: Add 008 value builder plugin for MARC21 classifications
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: MARC Authority data support (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Jacek Ablewicz
QA Contact: Marcel de Rooy
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-09-01 19:10 UTC by Jacek Ablewicz
Modified: 2017-05-19 06:33 UTC (History)
7 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Bot Control: ---
When did the bot last check this:
Who signed the patch off:
Text to go in the release notes:
This patch adds a 008 cataloguing value builder for MARC21 classifications records (LCC, DDC/Dewey, UDC and so on). This is a starting point for supporting classification records in Koha.


Attachments
Bug 17233 - Add 008 value builder plugin for MARC21 classifications (13.59 KB, patch)
2016-09-01 19:38 UTC, Jacek Ablewicz
Details | Diff | Splinter Review
[SIGNED-OFF] Bug 17233 - Add 008 value builder plugin for MARC21 classifications (13.66 KB, patch)
2017-01-09 19:43 UTC, M. Tompsett
Details | Diff | Splinter Review
Bug 17233 - Add 008 value builder plugin for MARC21 classifications (13.74 KB, patch)
2017-03-20 10:43 UTC, Marcel de Rooy
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Jacek Ablewicz 2016-09-01 19:10:34 UTC
This patch adds 008 cataloguing value builder for MARC21 classifications records (LCC, DDC/Dewey, UDC and so on).

For most practical purposes, MARC21 classification records (<https://www.loc.gov/marc/classification/>) are quite similar to regular MARC21 authority records, so handling them in Koha is (almost) achievable by means of the built-in 'regular' MARC21 authority records related functionalities, but there are some notable differences - in particular, 008 field length and format is not the same.
Comment 1 Jacek Ablewicz 2016-09-01 19:38:00 UTC
Created attachment 55098 [details] [review]
Bug 17233 - Add 008 value builder plugin for MARC21 classifications

This patch adds 008 cataloguing value builder for MARC21 classifications
records (LCC, DDC/Dewey, UDC and so on).

For most practical purposes, MARC21 classification records
(<https://www.loc.gov/marc/classification/>) are quite similar to regular
MARC21 authority records, so handling them in Koha is (almost) achievable
by means of the built-in 'regular' MARC21 authority records related
functionalities, but there are some notable differences - in particular,
008 field length and format is not the same.

To test:

1) apply patch
2) link the new plugin (marc21_field_008_classifications.pl) to the 008
field in the existing (or cloned, ..) authority framework of your choice
3) try to add, edit, re-edit 008 field using this "authority" framework,
ensure that the new plugin behaves as it should according to the
Library of Congress specifications for MARC21 classification records
008 field format (<https://www.loc.gov/marc/classification/cd008.html>).
Comment 2 M. Tompsett 2017-01-09 19:43:06 UTC
There was another plug in that did a really cool single line at the top and highlight and update thing, but this generally works.

An improvement would be highlighting changes, because if I put an invalid value in the field and then call up the builder, it defaults to a valid value in the part that is invalid.

But I don't think this is a reason to block this. Signing off.
Comment 3 M. Tompsett 2017-01-09 19:43:36 UTC
Created attachment 58716 [details] [review]
[SIGNED-OFF] Bug 17233 - Add 008 value builder plugin for MARC21 classifications

This patch adds 008 cataloguing value builder for MARC21 classifications
records (LCC, DDC/Dewey, UDC and so on).

For most practical purposes, MARC21 classification records
(<https://www.loc.gov/marc/classification/>) are quite similar to regular
MARC21 authority records, so handling them in Koha is (almost) achievable
by means of the built-in 'regular' MARC21 authority records related
functionalities, but there are some notable differences - in particular,
008 field length and format is not the same.

To test:

1) apply patch
2) link the new plugin (marc21_field_008_classifications.pl) to the 008
field in the existing (or cloned, ..) authority framework of your choice
3) try to add, edit, re-edit 008 field using this "authority" framework,
ensure that the new plugin behaves as it should according to the
Library of Congress specifications for MARC21 classification records
008 field format (<https://www.loc.gov/marc/classification/cd008.html>).

Signed-off-by: Mark Tompsett <mtompset@hotmail.com>
Comment 4 Marcel de Rooy 2017-03-17 11:21:49 UTC
Question: I am not familiar with MARC21 classification records. But I understand that they are not the same as authority records. Are we introducing here some workaround to use authorities as classifications? Strictly speaking, improper use?
Since this only is a plugin, we do no harm here. But what would be the next step? How are you using this? What is the future for classifications in Koha?

Changing status to reflect need for feedback.
Comment 5 Katrin Fischer 2017-03-17 11:26:01 UTC
Not sure if this is true in general, but we get classification records from our union catalog in the same file as the other authority records. We currently don't import them, but last time I investigated it looked like we'd just need a framework and some additional mappings for the main heading (hardcoded in some places) to make it work.
Comment 6 Jacek Ablewicz 2017-03-17 12:53:02 UTC
As far as I know, for all practical purposes, classification records (or "classification authority records" in other nomenclature) are authority records, just slightly different kind than "ordinary" authority records.

LoC classification records are generally speaking, numeric classification records (of different types: UDC, Dewey, and so on) controlled by an authority. In MARC21 biblio records, classification numbers are typically in 08X fields, and in the authority record, corresponding classification number is (usually ?) in the heading field with 153 tag.

But, as Katrin said, for such "classification authority records" to be fully functional in Koha, apart from user-configurable stuff like frameworks, zebra indexes etc., you need to make some changes (additions) in the code too:

    - C4/Heading/MARC21.pm
    - C4/AuthoritiesMarc.pm

because tag numbers and subfields for a given authority types are hard coded in there. For example (we are using UDC numerical classification in here), we needed to add definitions for 080 and 153 tags in aforementioned files, because they were not supported by default.
Comment 7 Marcel de Rooy 2017-03-20 10:43:01 UTC
Created attachment 61260 [details] [review]
Bug 17233 - Add 008 value builder plugin for MARC21 classifications

This patch adds 008 cataloguing value builder for MARC21 classifications
records (LCC, DDC/Dewey, UDC and so on).

For most practical purposes, MARC21 classification records
(<https://www.loc.gov/marc/classification/>) are quite similar to regular
MARC21 authority records, so handling them in Koha is (almost) achievable
by means of the built-in 'regular' MARC21 authority records related
functionalities, but there are some notable differences - in particular,
008 field length and format is not the same.

To test:

1) apply patch
2) link the new plugin (marc21_field_008_classifications.pl) to the 008
field in the existing (or cloned, ..) authority framework of your choice
3) try to add, edit, re-edit 008 field using this "authority" framework,
ensure that the new plugin behaves as it should according to the
Library of Congress specifications for MARC21 classification records
008 field format (<https://www.loc.gov/marc/classification/cd008.html>).

Signed-off-by: Mark Tompsett <mtompset@hotmail.com>

Signed-off-by: Marcel de Rooy <m.de.rooy@rijksmuseum.nl>
Comment 8 Marcel de Rooy 2017-03-20 10:44:03 UTC
(In reply to Jacek Ablewicz from comment #6)
> But, as Katrin said, for such "classification authority records" to be fully
> functional in Koha, apart from user-configurable stuff like frameworks,
> zebra indexes etc., you need to make some changes (additions) in the code
> too:
> 
>     - C4/Heading/MARC21.pm
>     - C4/AuthoritiesMarc.pm
> 
> because tag numbers and subfields for a given authority types are hard coded
> in there. For example (we are using UDC numerical classification in here),
> we needed to add definitions for 080 and 153 tags in aforementioned files,
> because they were not supported by default.

Would these adjustments be interesting too for the community?
Comment 9 Marcel de Rooy 2017-03-20 10:45:17 UTC
Passing QA on this patch with reference to the discussion above.
Comment 10 Kyle M Hall 2017-03-31 14:29:46 UTC
Pushed to master for 17.05, thanks Jacek!
Comment 11 Katrin Fischer 2017-04-02 17:38:32 UTC
This won't get ported back to 16.11.x as it is an enhancement.
Comment 12 Héctor Eduardo Castro Avalos 2017-05-17 16:27:46 UTC
Hi Marcel
 
> Would these adjustments be interesting too for the community?

Of-course these adjustments are interesting specially for librarian and catalogers, but just one comment.

This kind of record really need to be recorded in a separate table or database, since they tend to grow-up, imagine if you enter all SCDD21 or UDC schemas in conjunction with your authority works, will be chaos.

If you want to export all classification records it is much better to get this records in separate database not mixed with another type or record.

I like Koha but there are some things that need to be improved, for example MARC21 Holding, Free floating subdivision and of course classification records.

The problem here is that Koha is developed by software engineers and they do not really consult librarian.

Librarian thought

Regards
Comment 13 Chris Cormack 2017-05-17 22:36:32 UTC
(In reply to Héctor Eduardo Castro Avalos from comment #12)

> The problem here is that Koha is developed by software engineers and they do
> not really consult librarian.

This is both unhelpful, insulting and blatantly wrong. 
Many of the developers are trained librarians, and I doubt a single feature in Koha has been added without being specced and asked for by librarians.

Trying to divide the community will not result in a better system

Please stop
Comment 14 Héctor Eduardo Castro Avalos 2017-05-18 15:02:32 UTC
(In reply to Chris Cormack from comment #13)

Hi Chris

> This is both unhelpful, insulting and blatantly wrong.
> Many of the developers are trained librarians, and I doubt a single feature
> in Koha has been added without being specced and asked for by librarians.
> 
> Trying to divide the community will not result in a better system
> 
> Please stop

I wasn't try to insult anybody with a simple commentary. Ok, I accept that commentary is in the wrong way, but at the same time, I think it's not the way to react. I accept that you call my attention, but not in that way.
And of course I do not want to divide the community, I think that this project is a good effort of many people around the world like you, who has spent a lot of time developing Koha.

Please accept my apologize.

Regards